
from osv import osv, fields
from tools.translate import _
from lxml import etree

class Bank(osv.osv):
    _description='Bank'
    _inherit = 'res.bank'
    
    _columns = { 
                'swift':fields.char('Swift code',size=11,help="Bank Identifier Code"),
                }
    
    def fields_view_get(self, cr, uid, view_id=None, view_type=False, context=None, toolbar=False, submenu=False):
        
     
        res = super(Bank,self).fields_view_get(cr, uid, view_id=view_id, view_type=view_type, context=context, toolbar=toolbar, submenu=submenu)
        
        node=etree.fromstring(res['arch'])    

        if node.tag=='form':
            
            for each in node.findall('field'):
                if each.attrib['name']=='bic':
                    each.set('string','BIC code')

            res['arch']=etree.tostring(node)
            
        if node.tag=='search':    
            grp=node.find('group')
            for each in grp.findall('field'):
                if each.attrib['name']=='bic':
                    each.set('string','BIC code')
            
            
            res['arch']=etree.tostring(node)

        return res
        
    
Bank()    
    


class event_operation(osv.osv):

    _name = 'event.operation'
 
    _columns = {
                'name':fields.char('Name',size=64, required=True ),    
                'remark':fields.text('Remark'),
                }

event_operation()

class EventActivity(osv.osv):

    _name="event.activity"
    _description=__doc__
    
    _columns={
              'name':fields.char('Name',size=64,required=True ),
              }
    
#    _sql_constraints=[('unique name','unique(name)','Name should be unique!')]

EventActivity()

class EventContact(osv.osv):

    _name="event.contact"
    _description=__doc__
    
    _columns={
              'name':fields.char('Name',size=64,required=True ),
              }
    
#    _sql_constraints=[('unique name','unique(name)','Name should be unique!')]

EventContact()


class EventToVisit(osv.osv):

    _name="event.tovisit"
    _description=__doc__
    
    _columns={
              'name':fields.char('Name',size=64,required=True ),
              }
    
#    _sql_constraints=[('unique name','unique(name)','Name should be unique!')]

EventToVisit()


class event_vat(osv.osv):

    _name = 'event.vat'
 
    _columns = {
                'name':fields.float('Vat %', digits=(16,2), required=True ),    
                'remark':fields.text('Remark'),            
                }
event_vat()


class event_margin_coeff(osv.osv):

    _name = 'event.margin.coeff'
 
    _columns = {
                'name':fields.char('Name', size=64, required=True ),
                'value':fields.float('Coefficient %', digits=(16,2), required=True ),
            
                }
            
event_margin_coeff()


class EventWinLost(osv.osv):

    _name="event.winlost"
    _description=__doc__
    
    _columns={
              'name':fields.char('Condition',size=64,required=True),
              }
    
    _sql_constraints=[('unique name','unique(name)','Value should be unique!')]

EventWinLost()











