
import time
from report import report_sxw
from tools import amount_to_text_en
from decimal import *



class EventReport(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context=None):
        
        super(EventReport, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'image_func':self.image_func,
            'product_func':self.product_func,
            'product_func2':self.product_func2,
            'print_services':self.print_services,
            'calculate_total':self.calculate_total,
            'print_description':self.print_description,
            'calculate_date':self.calculate_date,
        })
        
    def image_func(self,ids):
   
       res={'0':False,'1':False,'2':False}
       result=[]
       i=0
      
       for each in ids:
           
           res[str(i)] = each.image
           i+=1
           
       result.append(res)

       return result
   
    def product_func(self,line):
        
        date_list=[]
        for each in line:
            if each.day not in date_list:
                date_list.append(each.day)
        
        return date_list
   
    def calculate_total(self,product,service):
        
        quantity=0.0
        total=0.0
        
        if product.quantity:
            quantity=product.quantity
            capacity=product.unit_cap
        if service:
            total=(quantity or 0.0)*(capacity or 0.0)*(service.sale_price or 0.0)
       
        return round(total,2)
    
    def calculate_date(self,date):
        
        print 
        
        if not date.val:
           
            return '-'
        
    
        return time.strftime('%A,%d %B %Y', time.strptime(date.val,'%Y-%m-%d'))
        
#        if product.quantity:
#            quantity=product.quantity
#        
#        if service:
#            total=quantity*(service.unit_cap or 0.0)*(service.sale_price or 0.0)
#       
#        return round(total,2)
   
#    def product_func(self,line):
#        
#        res={}
#        product_list=[]
#        for each in line:
#                    
#            if not res.get(each.day,''):
#                res[each.day]=[]
#            
#            if each.day in res.keys():    
#                res[each.day].append(each.product_id.name)
#                
#        return res
#    
    def print_services(self,services):
        
        service_list=[]
        
        for each in services:
            service_list.append(each.service_id)
       
        return service_list or False

    def print_description(self,line,date):
       
        description_list=[]
        
        for each in line:
            if each.day==date:
                description_list.append(each.name)
       
        description_str='-'.join(description_list)
       
#        description_list=[]
#        
#        for each in line:
#            if each.day==date:
#                description_list.append(each.product_id.description)
#       
#        description_str='-'.join(description_list)
       
        return description_str or False


    def product_func2(self,line,day,description=0):
      
        product_list=[]
        description_list=[]
        for each in line:
            if not description:
                if each.day==day:
                    product_list.append(each.product_id)
          
            description_list.append(each.product_id.description)    
        
        if description:
         
          return str(description_list)
      
        return product_list
    
   
    
report_sxw.report_sxw('report.events.quotation.report','event.quotation','addons/french_event/reports/quotation_report.rml',parser=EventReport)    
    

class InvoiceReport(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context=None):
        
        super(InvoiceReport, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'product_func':self.product_func,
            'product_func2':self.product_func2,
            'print_services':self.print_services,
            'calculate_total':self.calculate_total,
            'amount_vat':self.amount_vat,
            'amount':self.amount,
        })
        
    def amount(self,amount):
        
        if not amount:
            return 0.0
        
        return Decimal(str(amount)).quantize(Decimal(10)**-2)
        
    def amount_vat(self,order_line,vat_type=1):
        
        vat_19=0.0
        vat_55=0.0
        
        for order in order_line:
            for each in order.service_ids:
             
                if  each.vat=='19.6':
                    vat_19+=(each.total or 0.0)*(float(each.vat) or 0.0)/100
                    
                elif each.vat=='5.5':
                    vat_55+=(each.total or 0.0)*(float(each.vat) or 0.0)/100
                        
        
        if vat_type==1:
            return Decimal(str(vat_19)).quantize(Decimal(10)**-2)
        elif vat_type==2:
            return Decimal(str(vat_55)).quantize(Decimal(10)**-2)
        
        return 0.0
    
    def calculate_total(self,product,service):
        
        quantity=0.0
        total=0.0
        
        if product.quantity:
            quantity=product.quantity
            capacity=product.unit_cap
        if service:
            total=(quantity or 0.0)*(capacity or 0.0)*(service.sale_price or 0.0)
     
        return Decimal(str(total)).quantize(Decimal(10)**-2)     
        
    def product_func(self,line):
        
        date_list=[]
        for each in line:
            if each.day not in date_list:
                date_list.append(each.day)
        
        return date_list    
    
    def print_services(self,services):
        
        service_list=[]
        
        for each in services:
            service_list.append(each.service_id)
       
        return service_list or False

   

    def product_func2(self,line,day,description=0):
      
        product_list=[]
        description_list=[]
        for each in line:
            if not description:
                if each.day==day:
                    product_list.append(each.product_id)
          
            description_list.append(each.product_id.description)    
        
        if description:
         
          return str(description_list)
      
        return product_list
    
    
report_sxw.report_sxw('report.events.invoice.report','event.quotation','addons/french_event/reports/invoice_report.rml',parser=InvoiceReport)    
    
    
class CatalogueReport(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context=None):
        
        super(CatalogueReport, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'image_func':self.image_func,
            'calculate_total':self.calculate_total,
        })
        
    def image_func(self,ids):
       
     
       res={'0':False,'1':False,'2':False}
       result=[]
       
       i=0
      
       for each in ids:
           
           res[str(i)] = each.image
           i+=1
           
       result.append(res)

       return result
   
    def calculate_total(self,product,service):
        
        quantity=0.0
        total=0.0
        
        if product.quantity:
            quantity=product.quantity
        
        if service:
            total=quantity*(service.unit_cap or 0.0)*(service.sale_price or 0.0)
       
        return round(total,2)
   
    
report_sxw.report_sxw('report.events.catalogue.report','event.package','addons/french_event/reports/catalogue_report.rml',parser=CatalogueReport)    
    












    